MOD_BOX=1
MOD_BOX2=1
MOD_WIND=1
MOD_MENU=1
MOD_HEXA=0
MOD_DECI=0
MOD_ACC=0
NR_WINDOWS_MAX=2

QUI	equ 0	; 0 wax,gen, 2 : roro

No_ver_1=1		; 1
No_ver_2=0		;  .0
No_ver_3=2		;    1

	include guw_mac3.s

	comment HEAD=7

	; GEN & WAX Total Backup 9.0
	; (c) 19 / Novembre / 1993   Gen & Wax
	; 20-XI, 27-XI, 28-XI, 3-XII, 4-XII, 6-XII, 7-XII, 8-XII, 10-XII
	; 21-XII, 23-XII, 24-XII, 26-XII, 27-XII, 28-XII
	; (c) 8 / Janvier / 1994 Gen & Wax
	; 9-I, 15-I, 27-II
taille=32768

	; 6'15'' pour 2.8 MB sans cache-disque & avec Paula II 25 KHz
	; 3'35'  pour le meme sans cache, rien , en 16 coul.
	;~8'00'  pour 7.8 MB (stand-alone big file)

	section TEXT

debut:	init_prg 1024,#name_rsc

	bsr save_path
	bsr save_my_own_path
	bsr load_preferences

	bsr set_path
	tst d7
	bmi errare

	bsr init_rsc

	bsr show_menu

	lea window1,a0	; largeur,hauteur buffer et largeur,hauteur  l'ouverture
	bsr create_page	; attribut
	tst d7
	bmi errare
	move d7,index_window1

	move.w index_window1,d0
	bsr open_window
	*move.w index_window1,d0
	*bsr force_update

	lea window2,a0	; largeur,hauteur buffer et largeur,hauteur  l'ouverture
	bsr create_page	; attribut
	tst d7
	bmi errare
	move d7,index_window2

	move.w index_window2,d0
	bsr open_window
	*move.w index_window2,d0
	*bsr force_update

menu:
	bsr rends_memoire
	bsr write_sets_contents

boucle_gem_principale:
	clr d0
	bset #EVNT_KEYBD,d0
	bset #EVNT_MESAG,d0
	bsr traite_evenement_gem

az:	btst #EVNT_KEYBD,d0
	bne.s keyboard

	btst #EVNT_MESAG,d0
	bne message

	bra.s boucle_gem_principale

keyboard:	lea conversion,a0
	bsr convert_key_in_event
	tst d7
	bne boucle_gem_principale

message:
	lea tableau_routine,a0
.search:	tst.w (a0)
	beq.s boucle_gem_principale
	cmp.w (a0),d1
	beq.s .found
	lea 6(a0),a0
	bra.s .search
.found:	move.l 2(a0),a0
	jsr (a0)
	bra.s menu

quitter_prg:lea 4(a7),a7
	
errare:	bsr rends_memoire
	restore_prg

 DATA
tableau_routine:
	dc.w INFO_MENU
	dc.l INFORMATION
	dc.w BCK_MENU
	dc.l BACKUP
	dc.w ADD_BCK_MENU
	dc.l ADD_TO_BACKUP
	dc.w RST_ALL_MENU
	dc.l RESTORE
	dc.w RST_SELC_MENU
	dc.l RESTORE_SELC
	dc.w CSTCT_SET_MENU
	dc.l CONSTRUCT
	dc.w QUIT_MENU
	dc.l QUITTER_PRG
	dc.w INFO_DISK_MENU
	dc.l INFOS_ON_DISK
	dc.w OPTIONS_MENU
	dc.l FORM_OPTIONS
	dc.w SAVE_OPT_MENU
	dc.l SAVE_PREFERENCES
	dc.w 0

 TEXT

*------------------------------------------------------------------------
;R	E	S	T	O	R	E
*------------------------------------------------------------------------
init_restore:
	bsr rends_memoire
	move.w #-1,current_disk
	move.w #-1,current_track
	move.w #-1,tous_fich
	rts
*--------------------------------------------------------------
RESTORE_SELC:
	move.w #1,selc_flag
	bsr RESTORE
	clr.w selc_flag
	rts
*--------------------------------------------------------------
RESTORE:	bsr.s init_restore

	bsr set_default_if_any

	bsr set_path	; quel set ?
	move.l #'*.GW',whato
	move.w #'B'*256,whato+4
	lea text_sets,a0
	bsr copy_in2_select
	bsr fileselect
	clr d7
	tst d4
	beq fin_restore

	lea params_it,a0	; copie le nom du set pour + tard
	lea set_name,a1
cp_setn:	move.b (a0)+,(a1)+
	tst.b -1(a1)
	bne.s cp_setn

	file_open read,params_it	; FILE OPEN
	move d0,d7
	tst d7
	bmi err_open
	move d0,handle

	move.l #'*.*'*256,whato	; quel chemin de restore
	lea text_restore,a0
	bsr copy_in2_select
	bsr fileselect
	clr d7
	tst d4
	beq fin_restore

	appel dos,$19,2	; calcule path de base pour restore
	lea user_path,a4
	move.b #'A',(a4)
	add.b d0,(a4)+
	move.b #':',(a4)+	; A: ou B: ...
	clr.w -(sp)
	pea (a4)		; + \sources\
	appel dos,$47,8	; get_path
t_zer:	tst.b (a4)+
	bne.s t_zer		; on rajoute \  la fin
	move.b #'\',-1(a4)
	clr.b (a4)
	move.l a4,ad_user_path	; sauve ad pour plus tard

	file_read #buffer,#64+6,handle
	move.w buffer+64,save_entire_path
	move.w buffer+66,d0
	move.w #-204,d7
	cmp.w #$8f8a,d0
	bne not_a_set
	move.w buffer+68,d0
	cmp.w No_ver,d0
	bne not_a_set

	move.w index_window2,d0
	lea restoring,a0
	bsr write_in_window

	clr.b buffer+64		: maintenant on s'en fou

	move.w index_window2,d0
	lea buffer,a0
	bsr write_in_window
	move.w index_window2,d0
	lea lf_rc,a0
	bsr write_in_window

next_res:	file_read #info_on_file,#256,handle
	cmp.l #256,d0
	beq.s record_ok
	tst.l d0
	beq the_end_r
	move.w #-203,d7
	bra fini_res

record_ok:
	lea info_on_file+15+3,a0	; saute C:\ de toute faon

	tst save_entire_path		; path racourci ?
	bne.s long_ver
	subq.l #3,a0		; C:\
long_ver:
	move.l ad_user_path,a1
recop_u_p:	move.b (a0)+,(a1)+
	tst.b -1(a1)
	bne.s recop_u_p

	move.w index_window2,d0
	lea filus,a0
	bsr write_in_window
	move.w index_window2,d0
	lea user_path,a0
	bsr write_in_window

	tst selc_flag
	beq.s .no_selc

	lea question,a0
	move.w index_window2,d0
	bsr write_in_window
.no_keyboard:
	clr d0
	bset #EVNT_KEYBD,d0
	bsr traite_evenement_gem

	btst #EVNT_KEYBD,d0
	beq.s .no_keyboard

	cmp.b #'n',d1
	bne.s .pas_non
	clr d7
	bra .pas_next
.pas_non:	cmp.b #'c',d1
	bne.s .pas_cancel
	lea cancelled,a0
	move.w index_window2,d0
	bsr write_in_window
	move.w #-201,d7
	bra .pas_next
.pas_cancel:cmp.b #'y',d1
	bne.s .no_keyboard

.no_selc:	bsr.s restore_file
	cmp.w #-207,d7
	bne.s .pas_next
	clr d7		; on fait un skip si erreur de lecture TRACK
.pas_next:	tst d7
	bmi.s fini_res

	cmp.w #0,d7
	bne.s pas_sauter_fich
	move.w index_window2,d0
	lea file_skipped,a0
	bsr write_in_window
pas_sauter_fich:
	cmp.w #1,d7
	bne.s pas_cree_fich
	move.w index_window2,d0
	lea file_written,a0
	bsr write_in_window
pas_cree_fich:
	cmp.w #2,d7
	bne next_res
	move.w index_window2,d0
	lea file_overwritten,a0
	bsr write_in_window
	bra next_res

the_end_r:	clr d7

fini_res:	file_close handle

fin_restore:
err_open:
	bsr rends_memoire
	rts

not_a_set:	bsr not_right_v		; not right version
	bra.s the_end_r
	*------------------------------------------------
	; se sert de :
	;	info_on_file
	;	user_path
restore_file:
	bsr test_if_exists
	move d7,etat_fichier
	tst d7
	beq no_restore		; 0 Skip
	bmi no_restore		; <0 annule

	cmp.w #1,d7			; 1 doesn't exist
	beq.s no_ex
	clr.w -(sp)			; 2 overwrite
	move.w #1,-(sp)		; fixer en r/w
	pea user_path		; nom
	appel dos,$43,10
no_ex:
	move.l info_on_file+6+4,taille_fich	; not 3 bombes

	move.w info_on_file,d0		; No Disk
	move.l info_on_file+2,d1	; offset ds disk
	bsr init_ptrs_read
	tst d7
	bmi no_restore

	moveq.l #2,d0
	bsr lit_n_octets
	tst d7
	bmi no_restore
	clr.l d0
	move.w buffer,d0
	bsr lit_n_octets		; pour rien
	tst d7
	bmi no_restore

fini_create_dirs:
	file_open write,user_path
	cmp.w #-34,d0
	beq create_dirs
	move d0,handle_res

read_file:
	move.l taille_fich,d0
	cmp.l #taille,d0
	blt.s not_32768
	move.l #taille,d0
not_32768:	tst.l d0
	beq.s not_0

	save d0
	bsr lit_n_octets		; d0 inchang
	load d0
	tst d7
	bmi pb_restore
	bsr etat_touches_spe
	tst d7
	bmi.s pb_restore

	save d0
	file_write #buffer,d0,handle_res
	load d0
	sub.l d0,taille_fich

	cmp.l #taille,d0
	beq.s read_file

not_0:	move.w #1,-(sp)		; fixer
	move.w handle_res,-(sp)
	pea info_on_file+6
	appel dos,$57,10		; sets time/date

	file_close handle_res

; Comparer longueur enregistre dans le rapport avec celle lue
*	cmp.l 

	clr d0			; ne fixer l'attribut que
	move.b info_on_file+6+8,d0
	move.w d0,-(sp)		; aprs fermeture
	move.w #1,-(sp)		; fixer
	pea user_path
	appel dos,$43,10

	move etat_fichier,d7
no_restore:	rts

pb_restore:	file_close handle_res
	pea user_path
	appel dos,$41,6		; Fdelete
	rts

create_dirs:lea user_path,a0
	lea dummy_path,a1
c_z:	move.b (a0)+,d0
	move.b d0,(a1)+
	bne.s c_z
c_a:	subq.l #1,a0
	cmp.b #'\',-(a1)
	bne.s c_a
	clr.b (a1)
	save a0/a1
	pea dummy_path
	appel dos,$39,6
	load a0/a1
	tst d0
	bmi.s c_a

c_p:	move.b (a0),(a1)
c_z2:	addq.l #1,a1
	addq.l #1,a0
	tst.b (a1)
	bne.s c_z2
	tst.b (a0)
	beq fini_create_dirs

	save a0/a1
	pea dummy_path
	appel dos,$39,6
	load a0/a1

	bra.s c_p
		*---------------------
; D0.W : No du disk
; D1.L : Offfset / au dbut des donnes inscriptibles

init_ptrs_read:
	cmp.w current_disk,d0
	beq.s pas_change_disk
	
	save d0/d1
	bsr insert_this_disk
	load d0/d1
	tst d7
	bmi troc

pas_change_disk:
	clr d6
	cmp.w current_disk,d0
	bne.s not_the_s
	moveq #1,d6
not_the_s:	move.w d0,current_disk

	move.w longueur_secteur,d2
	ext.l d2		; offset / dbut inscriptible du disk:
	add.l d2,d1		; on additionne la longueur du 1 secteur

	move.l d1,d2
	divu longueur_secteur,d2
	ext.l d2
	divu nb_sec_pistes,d2
	ext.l d2
	divu nb_faces,d2

	cmp.w current_track,d2
	bne.s not_the_s2
	addq #1,d6
not_the_s2:	move.w d2,current_track

	mulu nb_faces,d2
	mulu nb_sec_pistes,d2
	mulu longueur_secteur,d2
	sub.l d2,d1
	move.l d1,ptr_buff_read

	move.w nb_faces,d2	; on lit les 2 faces en meme temps
	mulu.w nb_sec_pistes,d2
	mulu longueur_secteur,d2
	sub.l d1,d2
	move.l d2,nb_oct_ds_buff

	cmp.w #2,d6
	beq.s wonderful	; ne pas relire : c'est la meme

	bsr rends_memoire

	move.w nb_faces,d0
	mulu nb_sec_pistes,d0
	mulu longueur_secteur,d0	; 1 piste : 2 faces

	bsr xmalloc
	tst.l d0
	bgt.s no_bug_mem2

	move.l d0,d7
	bsr erreur_mem		; erreur
	bra.s troc

no_bug_mem2:
	move.l d0,ad_malloc
	add.l d0,ptr_buff_read

	move current_track,d0
	clr d7

	move.l ad_malloc,a0
	bsr read_one_track

troc:	rts

wonderful:	move.l ad_malloc,d0
	add.l d0,ptr_buff_read
	clr d7
	rts
		*---------------------
insert_this_disk:
	clr disque_courant
	move d0,num_disk
grocky:	bsr please_insert_disk
	tst d7
	bmi.s connardos

	move disque_courant,d0
	beq.s grocky		; pas un disk gwbck
	cmp.w num_disk,d0
	bne.s grocky

	move.l set_name,d0
	cmp.l boot_secteur+($1c+2+name_report-debut_boot),d0
	bne.s grocky
	move.l set_name+4,d0
	cmp.l boot_secteur+($1c+2+name_report-debut_boot)+4,d0
	bne.s grocky

	bsr calcule_all_from_boot_info

	clr d7
connardos:	rts
		*---------------------
lit_n_octets:		; =====> buffer
	lea buffer,a1
lit_n_octets2:
	move.l ptr_buff_read,a0
	move.l nb_oct_ds_buff,d1
	cmp.l d0,d1
	blt.s not_enough_in_cache

	move.l d0,d2
recop_rd:	move.b (a0)+,(a1)+
	subq.l #1,d2
	bne.s recop_rd
	move.l a0,ptr_buff_read
	sub.l d0,nb_oct_ds_buff
	clr d7
	rts

not_enough_in_cache:
	move.l d1,d2
	beq.s deja_vide
recop_rd2:	move.b (a0)+,(a1)+
	subq.l #1,d2
	bne.s recop_rd2
	sub.l d1,d0
deja_vide:

	save d0/a1
	bsr.s rempli_buffer		; les ptrs sont resets
	load d0/a1
	tst d7
	bpl.s lit_n_octets2
	rts
		*---------------------
rempli_buffer:
	addq #1,current_track
	move current_track,d0
	cmp.w nb_pistes,d0
	bge.s call_new_disk

	move.l ad_malloc,a0
	bsr.s read_one_track
	tst d7
	bmi.s err5

	move.l ad_malloc,ptr_buff_read
	move.w nb_faces,d0
	mulu nb_sec_pistes,d0
	mulu longueur_secteur,d0
	move.l d0,nb_oct_ds_buff
	clr d7
err5:	rts

call_new_disk:
	move.w current_disk,d0		; No Disk
	addq.w #1,d0
	clr.l d1
	bsr init_ptrs_read
	tst d7
	bmi.s err5
	clr d7
	rts
		*---------------------
test_if_exists:
	file_open read,user_path
	tst d0
	bmi.s no_exist
	file_close d0

	move.w tous_fich,d7
	bpl.s sur_tous

	bsr warning_exist
	rts
no_exist:	moveq #1,d7		; 1 n'existe pas
sur_tous:	rts

		*---------------------
read_one_track:		; d0 track
	clr d1
redo_1:	save d0/d1/a0
	move.w nb_sec_pistes,-(sp)
	move.w d1,-(sp)
	move.w d0,-(sp)	; track
	move.w #1,-(sp)	; first sec
	move.w #0,-(sp)	; A
	clr.l -(sp)
	mulu nb_sec_pistes,d1
	mulu longueur_secteur,d1
	add.l d1,a0
	pea (a0)		; add buffer une piste
	appel xbios,8,20
	move d0,d7
	load d0/d1/a0
	tst d7
	bmi.s err_lecture

	addq #1,d1
	cmp nb_faces,d1
	bne.s redo_1
	clr d7
	rts

err_lecture:save d0-d6/a0-a6
	bsr err_lect
	load d0-d6/a0-a6
	tst d7
	bpl.s redo_1
	rts
		*---------------------
	DATA
restoring:	dc.b lf,rc,'Description : ',0
filus:	dc.b lf,rc,'Working : ',0
file_skipped:
	dc.b '  Skipped.',0
file_written:
	dc.b '  Written.',0
file_overwritten:
	dc.b '  Replaced.',0
question:	dc.b ' (Yes/No/Cancel)',0
cancelled:	dc.b lf,rc,'End of restore.',0
	even

	BSS
	even
selc_flag:		ds.w 1
tous_fich:		ds.w 1
etat_fichier:	ds.w 1
at_least_once:	ds.w 1
info_on_file:	ds.b 256
handle_res:		ds.w 1
ptr_buff_read:	ds.l 1
nb_oct_ds_buff:	ds.l 1

current_track:	ds.w 1
current_disk:	ds.w 1
user_path:	ds.b 256
dummy_path:	ds.b 256
ad_user_path:ds.l 1
	TEXT
*------------------------------------------------------------
;C	O	M	M	O	N
*------------------------------------------------------------
etat_touches_spe:
	save d0-d6/a0-a6
	move.w  #-1,-(sp)	; Shift_Droit:1, SG:2 CTRL:4 ALT:8
	appel bios,11,4	; tat des touches spciales
	clr d7
	and.w #3,d0
	cmp.w #3,d0
	bne.s not_brk
	move #-201,d7
not_brk:	load d0-d6/a0-a6
	rts

read_boot_sector:
	move.w #1,-(sp)	; 1 secteur
	move.w #0,-(sp)	; face 0
	move.w #0,-(sp)	; piste 0
	move.w #1,-(sp)	; secteur 1 (BOOT)
	move.w #0,-(sp)	; lecteur A
	clr.l -(sp)
	pea boot_secteur
	appel xbios,8,20
	move.w d0,d7
	bmi.s .cool

	cmp.w #$0100,boot_secteur+26	; corrige erreur si boot fantaisiste
	beq.s .cool
	cmp.w #$0200,boot_secteur+26
	beq.s .cool
	move.w #-7,d7
.cool:	rts

rends_memoire:
	tst.l ad_malloc
	beq.s no_mem_render
	move.l ad_malloc,-(sp)
	appel dos,$49,6	; Mfree
	clr.l ad_malloc
no_mem_render:
	rts

xmalloc:	save d0
	bsr.s rends_memoire
	load d0
xmalloc2:	*move.w #3,-(sp)	; 0=ST, 1=TT, 2=ST->TT, 3=TT->ST
	*move.l d0,-(sp)	; d0 = longueur to malloc
	*appel dos,$44,8	; xmalloc
	move.l d0,-(sp)	; d0 = longueur to malloc
	appel dos,$48,6	; malloc
	rts


; Demande un disk, lit son boot et recommence jusqu' disk ok (d7=0) ou ABORT (d7<0)
please_insert_disk:
	save d0-d6/a0-a6

.insert_d:	bsr warning
	tst d7
	bmi.s .tantpis2

	bsr read_boot_sector
	tst d7
	bmi.s .insert_d

	clr disque_courant
	bsr.s is_dis_a_bck_dsk
	tst d7
	bmi.s .not_bck

	move boot_secteur+512-2,d0
	sub.w #'00',d0
	move d0,disque_courant

.not_bck:	clr d7
.tantpis2:	
	load d0-d6/a0-a6
	rts

calcule_all_from_boot_info:
	lea boot_secteur,a0
	move.b 12(a0),d0
	lsl.w #8,d0
	move.b 11(a0),d0
	move.w d0,longueur_secteur
	move.b 20(a0),d1
	lsl.w #8,d1
	move.b 19(a0),d1	; nbre total de secteur
	move.b 27(a0),d2
	lsl.w #8,d2
	move.b 26(a0),d2
	move.w d2,nb_faces
	move.b 25(a0),d3
	lsl.w #8,d3
	move.b 24(a0),d3
	move.w d3,nb_sec_pistes
	move d1,d4
	subq.w #1,d4	; moins le secteur boot
	mulu d0,d4
	move.l d4,espace_libre	; taille max disquette

	ext.l d1
	divu d2,d1
	ext.l d1
	divu d3,d1
	move.w d1,nb_pistes
	rts

is_dis_a_bck_dsk:
	move #-1,d7
	lea id_guw,a0	; compare l'ID
	lea boot_secteur+2,a1
	move #6-1,d0
.cmpid:	cmp.b (a0)+,(a1)+
	bne.s .pas_deja_backup
	dbf d0,.cmpid
	clr d7
.pas_deja_backup:
	rts

save_path:	appel dos,$19,2		; save current drive
	move d0,save_drive

	clr.w -(sp)			; save current path
	pea save_cpath
	appel dos,$47,8

	tst.b save_cpath
	bne.s not_rootp	; tout ca pour le module rcursif
	move.w #'\'*256,save_cpath
not_rootp:	rts

restore_path:
	move.w save_drive,-(sp)
	appel dos,$0e,4	; setdrive
	pea save_cpath
	appel dos,$3b,6	; set_path
	move d0,d7
	tst d7
	bmi.s pb_rest_path
	clr d7
pb_rest_path:rts

	BSS
save_drive:	ds.w 1
save_cpath:	ds.b 256
	TEXT

set_default_if_any:		; pour lire be boot & init du nom fileselect
	bsr read_boot_sector
	tst d7
	bmi.s no_default

	bsr.s is_dis_a_bck_dsk
	tst d7
	bmi.s no_default

	lea boot_secteur,a0
	lea 2+$1c+name_report-debut_boot(a0),a0
	lea params_it,a1	; fichier par dfaut pour fileselect
	move #8+1+3+1-1,d0
.cpdef:	move.b (a0)+,(a1)+
	dbf d0,.cpdef

no_default:	rts

insert_last_disk:
	clr disque_courant
.not_last:	bsr please_insert_last_disk
	tst d7
	bmi.s .tantpis

	clr disque_courant
	bsr read_boot_sector
	tst d7
	bmi.s .not_last

	bsr is_dis_a_bck_dsk
	tst d7
	bmi.s .not_last

	move boot_secteur+512-2,d0
	sub.w #'00',d0
	move d0,disque_courant

	move.l #'LAST',d0
	cmp.l boot_secteur+512-2-4-4,d0
	bne.s .not_last
	clr d7
.tantpis:	rts

*------------------------------------------------------------
;B	A	C	K	U	P
*------------------------------------------------------------
init_backup:
	move.w #0,num_disk

; Acquisition de l'heure systme pour crer le nom du fichier de rapport
	appel xbios,23,2	; gettime
	move.l d0,d2
	and.l #%00000000000000000000011111100000,d2
	lsr.l #5,d2
	divu #10,d2
	add.b #'0',d2
	move.b d2,set_name+6
	swap d2
	add.b #'0',d2
	move.b d2,set_name+7
	
	move.l d0,d2
	and.l #%00000000000000001111100000000000,d2
	lsr.l #5,d2
	lsr.l #6,d2
	divu #10,d2
	add.b #'0',d2
	move.b d2,set_name+4
	swap d2
	add.b #'0',d2
	move.b d2,set_name+5
	
	move.l d0,d2
	and.l #%00000000000111110000000000000000,d2
	lsr.l #8,d2
	lsr.l #8,d2
	divu #10,d2
	add.b #'0',d2
	move.b d2,set_name+0
	swap d2
	add.b #'0',d2
	move.b d2,set_name+1

	move.l d0,d2
	and.l #%00000001111000000000000000000000,d2
	lsr.l #8,d2
	lsr.l #8,d2
	lsr.l #5,d2
	divu #10,d2
	add.b #'0',d2
	move.b d2,set_name+2
	swap d2
	add.b #'0',d2
	move.b d2,set_name+3

; Creation du-dit fichier, saisie du descriptif (64.b)
	bsr set_path

	file_open write,set_name
	save d0

	bsr enter_descriptif

	move.l (sp),d0
	file_write #descriptif+2,#64,d0
	move.w save_entire_path,buffer
	move.w #$8f8a,buffer+2
	move.w No_ver,buffer+4
	move.l (sp),d0
	file_write #buffer,#6,d0
	load d0
	file_close d0

; Descriptif dans le boot qui sera recopi futurement sur chaque disque
	lea descriptif+2,a0
	lea desc_boot,a1
	move.w #64-1,d0
.recop_descr:move.b (a0)+,(a1)+
	dbf d0,.recop_descr

; On y rajoute le nom du fichier de rapport
	lea set_name,a0
	lea name_report,a1
	move.w #12-1,d0
.recop_name_r:
	move.b (a0)+,(a1)+
	dbf d0,.recop_name_r

init_backup2:
	bsr rends_memoire
	clr.w flag_cache
	clr.l espace_libre
	clr.l offset_write	; pour le tout premier
	clr.w longueur_secteur

	rts


*-----------------------------------------------------------------
extract_info:
	get_path #0,saving_path

	tst.b saving_path
	bne.s not_root	; tout ca pour le module rcursif
	move.w #'\'*256,saving_path
	move.l #3,save_base_root_lengh	; C:\
	bra.s ok_br
not_root:

	lea saving_path,a0	; calcule longueur base root  enlever
fd0:	tst.b (a0)+		; plus tard
	bne.s fd0		; \XXX0X <- pointe ici
	sub.l #saving_path-2,a0	; 7 pour C:\XXX\ 3 pour ROOT
	move.l a0,save_base_root_lengh
ok_br:		; en bref pointe sur le nom juste apres le '\'

	get_drive
	lea saving_path,a0
	lea params_it,a1
	rts
 BSS
saving_path:ds.w 128
 TEXT
*-----------------------------------------------------------------
traite:	move.w index_window2,d0
	lea flic,a0
	bsr write_in_window

	lea nom_fichier,a0
	tst save_entire_path
	bne.s save_a
	add.l save_base_root_lengh,a0
save_a:	move.w index_window2,d0
	bsr write_in_window

	lea nom_fichier,a0
	bsr backup_fichier
	rts
*------------------------------------------------------------
BACKUP:	bsr init_backup
	clr at_least_once

redo_next:	bsr restore_path

	tst.l sltr_adress
	beq.s no_trix

	tst.l are_there_more
	bne.s more
	move.l sltr_communication_word,a0
	move.w #3,(a0)
	move.l sltr_out_counter,a0
	move.w #256,(a0)
	move.l sltr_out_pointer,a0
	move.l #return_more_names,(a0)
	bra.s no_trix

more:	move.l are_there_more,a0
troc2:	lea params_it,a1
cpp:	move.b (a0)+,(a1)+
	tst.b -1(a1)
	beq.s that_was_last
	cmp.b #'\',-1(a1)
	beq.s that_was_anti	; slectrix met un \  la fin d'un dir : je le vire.
	cmp.b #' ',-1(a1)
	bne.s cpp
	clr.b -1(a1)
	move.l a0,are_there_more
	bra.s no_selector
that_was_last:
	clr.l are_there_more
	bra.s no_selector
that_was_anti:
	lea -1(a1),a1
	bra.s cpp
no_trix:

	move.l #'*.*'*256,whato
	lea text_back,a0
	bsr copy_in2_select
	bsr fileselect
	clr d7
	tst d4
	beq.s no_more_bck

	tst.l sltr_adress
	beq.s .no_trix2
	tst.b return_more_names
	beq.s .no_trix2		; aucune slection (*.S par ex)
	move.l #return_more_names,a0
	bra.s troc2
.no_trix2:

no_selector:

	bsr save_path

	bsr extract_info	; init mod-recurse + calcule root-path
	move recurse_subdirs,special_1
	move.w #1,special_2
	bsr find_all
	tst d7
	bmi.s erreur_backup	; si la moindre erreur : efface rapport
	bra redo_next

no_more_bck:tst at_least_once	; si rien backup alors efface rapport
	beq.s erreur_backup
	cmp.w #2,at_least_once
	beq.s pas_ecriture 	; si add2bck et rien crit
	bsr set_path
	lea set_name,a0	; on s'ajoutte soi meme
	bsr.s backup_fichier
	bsr vide_cache	; Vide le cache ventuel
	tst d7		; si erreur ?
	bmi.s erreur_backup
	clr affiche_sets

	tst delete_after_bck
	beq.s pas_ecriture
	bsr delete_files_after_backup
pas_ecriture:
	rts

erreur_backup:	; On efface le fichier de rapport si on a annul
	bsr set_path
	pea set_name
	appel dos,$41,6	; Fdelete
	rts
*------------------------------------------------------------
; Renvoie : D0.l longueur fichier ou -1.l pour erreur

backup_fichier:		; a0 : ad. du nom du fichier  backuper
	move.l a0,ad_name_fich
	file_open read,(a0)
	tst d0
	bmi not_exist
	move d0,handle

	bsr lit_info_fich
	move.l buffer+26,taille_fich

; construit fichier pour le restore
	bsr add_2_rapport
	tst d7
	bmi.s err3

; construit l'info pour le recover en cas de perte du set
	lea buffer+2,a1
	lea boot_secteur+6,a0	; l se trouvent aussi les infos
	move.w #9-1,d0	; dans le bon ordre (pas 3 bombes)
recop_header2:
	move.b (a0)+,(a1)+
	dbf d0,recop_header2

	move.l ad_name_fich,a0
recop_header:
	move.b (a0)+,(a1)+
	tst.b -1(a1)
	bne.s recop_header

	sub.l #buffer+2,a1
	move.w a1,buffer		; .W
	move.l a1,d0
	addq.l #2,d0
	bsr.s put_2_cache
	tst d7
	bmi.s err3

read_more:	file_read #buffer,#taille,handle
	tst.l d0
	beq.s fin_read

	bsr.s put_2_cache
	tst d7
	bmi.s err3
	bsr etat_touches_spe
	tst d7
	bmi pb_restore

	cmp.l #taille,d0
	beq.s read_more

fin_read:	clr d7
	move #1,at_least_once
err3:	file_close handle
	move.l taille_fich,d0
	rts
not_exist:	move d0,d7
	rts

		*---------------------
put_2_cache:save d0
	lea buffer,a0
write_more	bsr.s insert_new_disk
	tst d7
	bmi.s err2
	move.l d0,d1
	cmp.l espace_libre,d0
	ble.s taille_inf
	move.l espace_libre,d1
taille_inf:	bsr.s copy_2_cache
	sub.l d1,espace_libre
	sub.l d1,d0
	bne.s write_more
	clr d7
err2:	load d0
	rts

copy_2_cache:
	move.w #1,flag_cache
	move.l offset_write,a1
	add.l d1,offset_write
copy_file_in_cache:
	move.b (a0)+,(a1)+
	cmp.l offset_write,a1
	bne.s copy_file_in_cache
	rts

insert_new_disk:
	clr d7
	tst.l espace_libre
	bne not_full

	save d0/a0
	bsr vide_cache
	tst d7
	bmi erreur_disk

	addq #1,num_disk

another_dsk:bsr lit_info_boot
	tst d7
	bmi erreur_disk

	move.l espace_libre,d0
	move.w longueur_secteur,d1	; + BS
	ext.l d1
	add.l d1,d0			; + BS
	bsr xmalloc
	tst.l d0
	bgt.s no_bug_mem
	bsr erreur_mem
	bra.s another_dsk
	
no_bug_mem:	move.l d0,ad_malloc
	move.l d0,a0
	lea boot_secteur,a1	; recopie le BS
	move.w #30-1,d0
recopy_boot:move.b (a1)+,(a0)+
	dbf d0,recopy_boot

	move.l ad_malloc,a0
	addq.l #2,a0
	lea id_guw,a1	; met id
	move.w #6-1,d0
recop_id:	move.b (a1)+,(a0)+
	dbf d0,recop_id

	move.l ad_malloc,a0
	add.l #$1c+2,a0	; on saute les donnes vitales
	lea debut_boot,a1	; texte
	move.w #512-($1c+2)-1,d0
recop_txt:	move.b (a1)+,(a0)+
	dbf d0,recop_txt

	move num_disk,d0	; numro disquette
	add.w d0,-2(a0)

	move.w longueur_secteur,d0	; dans le cas ou le
	sub.w #512,d0		; BS <> 512 .B
	add.w d0,a0
	move.l a0,offset_write

	clr d7
erreur_disk:load d0/a0
not_full:	rts
		*---------------------
vide_cache:	clr d7
	tst.w flag_cache
	beq cache_vide

	move.l ad_malloc,a1
	move.w #$601c,(a1)	; bra $1c
	move.w #512/2-1,d0
	move.w #$1234,d1
.recop:	sub.w (a1)+,d1
	dbf d0,.recop
	move.l ad_malloc,a1
	move.w d1,chksum-debut_boot+2+$1c(a1)	; rend le boot executable

	move.l espace_libre,d0	; on n'crit pas tout dans le cas
	divu longueur_secteur,d0	; d'un disk non plein
	ext.l d0
	divu nb_sec_pistes,d0
	ext.l d0
	divu nb_faces,d0
	sub.w nb_pistes,d0
	neg.w d0
	move.w d0,last_piste	; dernire piste

	movem.l nb_faces,d0-d1	; sauvegarde des infos du boot (comparaison ulterieure)
	movem.l d0-d1,zone_tampon

reprend_from_neue_disque:
	bsr active_retry

	move.l ad_malloc,a0
	move.w #0,d0	; piste

other_track:move.w #0,d1	; face
other_side:	
	save d0/d1/a0
	bsr write_track
	load d0/d1/a0
	tst d7
	bpl.s no_pb_write
	cmp.w #-202,d7
	beq.s reprend_from_neue_disque
	bra.s stop_all
	
no_pb_write:move.w nb_sec_pistes,d2
	mulu longueur_secteur,d2
	add.l d2,a0
	addq.w #1,d1
	cmp.w nb_faces,d1
	bne.s other_side
	addq.w #1,d0
	cmp.w last_piste,d0
	bne.s other_track

	clr d7

	tst total_verify
	beq.s pas_verifi
	bsr verify_all_disk
	tst d7
	bpl.s pas_verifi
	cmp.w #-202,d7
	beq.s reprend_from_neue_disque
*	bra.s stop_all
	
pas_verifi:

stop_all:	bsr rends_memoire

	clr.w flag_cache
	clr.l espace_libre	; Quand on veut forcer la vidange
	clr.l offset_write	; pour le tout premier
	clr.w longueur_secteur
cache_vide:	rts

; Dsire un disque du meme format mais pas du meme set
 DATA
com:
env:	dc.w 0
 TEXT
		*---------------------
; demande un disk, previent si ce n'est pas un backup, refuse le meme set(sauf si meme No)
; et calcule les info. et l'espace libre
lit_info_boot:
	clr disque_courant
groc:	bsr please_insert_disk
	tst d7
	bmi.s connard

	bsr is_dis_a_bck_dsk
	tst d7
	beq.s deja_backup

; ce disk peut contenir des informations 
	bsr informe_user	; 0=overwrite
	tst d7
	bmi.s groc
	bra.s no_tst_sn

deja_backup:
	lea boot_secteur+($1c+2+name_report-debut_boot),a0
	lea set_name,a1
	move #8+1+3-1,d0
cmpb:	cmp.b (a0)+,(a1)+
	bne.s not_de_same
	dbf d0,cmpb

	move.w boot_secteur+512-2,d0
	sub.w #'00',d0
	cmp.w num_disk,d0
	bge.s not_de_same	; si ressaie le meme disque merdique aprs New disk

	bsr its_same_set
	bra.s groc		; c'est un disk du meme backup !!!!!!
no_tst_sn:
not_de_same:
	bsr calcule_all_from_boot_info

	clr d7
connard:	rts
		*---------------------

write_track:save d0/d1/a0
	move.w nb_sec_pistes,-(sp)
	move.w d1,-(sp)
	move.w d0,-(sp)
	move.w #1,-(sp)
	move.w #0,-(sp)
	clr.l -(sp)
	pea (a0)
	appel xbios,9,20
	move d0,d2
	load d0/d1/a0
	tst d2
	bpl.s no_error_write

commun1:	bsr error_write
	tst d7
	bpl.s write_track
	cmp.w #-202,d7
	beq.s new_disk
	cmp.w #-207,d7
	beq.s format
	rts

no_error_write:
	bsr etat_touches_spe
	*clr d7
	rts

new_disk:	bsr desactive_retry

	bsr lit_info_boot
	tst d7
	bmi.s commun1

	lea nb_faces,a0
	lea zone_tampon,a1
	move.w #8/2-1,d0
.compare:	cmp.w (a0)+,(a1)+
	bne.s n_s_f
	dbf d0,.compare

	move.w #-202,d7
	rts

n_s_f:	bsr not_same_f
	bra.s commun1

; lancement d'un formateur externe
format:	move.l #'*.*'*256,whato
	lea text_format,a0
	bsr copy_in2_select
	bsr fileselect
	tst d4
	beq.s commun1

	bsr hide_menu

	pea env
	pea com
	pea params_it
	clr.w -(sp)
	appel dos,$4b,16

	bsr show_menu

	bra new_disk
		*---------------------
verify_all_disk:
	move.w nb_sec_pistes,d0
	mulu nb_faces,d0
	mulu longueur_secteur,d0
	bsr xmalloc2
	tst.l d0
	beq.s pb_mem_ver

	move.l d0,ad_malloc_ver
	
	move.l ad_malloc,a1
	move.w #0,d0	; piste

.other_track:
	move.l ad_malloc_ver,a0
	save a1
	bsr read_one_track
	load a1

	tst d7
	bmi.s pb_read

	move nb_sec_pistes,d1
	mulu nb_faces,d1
	mulu longueur_secteur,d1
	lsr.l #2,d1
	subq.l #1,d1

.comp:	cmp.l (a0)+,(a1)+
	bne.s pb_read
	dbf d1,.comp

	addq.w #1,d0
	cmp.w last_piste,d0
	bne.s .other_track

	move.l ad_malloc_ver,-(sp)
	appel dos,$49,6	; Mfree

fin_ver:	clr d7
	rts

pb_read:	move.l ad_malloc_ver,-(sp)
	appel dos,$49,6	; Mfree

	bsr err_ver

	bsr desactive_retry
	bra commun1

pb_mem_ver:	bsr err_mem_ver
	clr d7
	rts

		*---------------------
merdouze:	lea boot_secteur,a1
	move.w num_disk,d0
	bne.s pas_premier
	moveq #1,d0		; parceque on update le rapport en 1er
pas_premier:move.w d0,(a1)+	; on va pas mettre disk 0 tout de meme?
	move.l offset_write,d0
	sub.l ad_malloc,d0
	move.w longueur_secteur,d1
	ext.l d1
	sub.l d1,d0		; % au dbut des donnes inscriptibles
	move.l d0,(a1)+
	lea buffer+21+1,a0	; pas 3 bombes
	move.w #8-1,d0
recop_info_fich:
	move.b (a0)+,(a1)+
	dbf d0,recop_info_fich
	move.b buffer+21,(a1)+
	rts

add_2_rapport:
;	pour avoir att/date/time/long meme si dernier

	bsr.s merdouze

	; ne pas toucher  a1
	; Pour ne rajouter le nom du fichier de rapport au rapport (sic)

	move.l ad_name_fich,a2	; pas de path pour ce nom l
	lea set_name,a3
	move.w #8+1+3-1,d0
test_me:	cmp.b (a2)+,(a3)+
	bne its_not_me
	dbf d0,test_me

	; Travail de finition : mettre le fichier de set sur disk

wz:	move.l offset_write,d0
	sub.l ad_malloc,d0
	move.w longueur_secteur,d1
	ext.l d1
	sub.l d1,d0		; % au dbut des donnes inscriptibles
	move.l d0,temp_for_last
	move.w num_disk,temp_for_last+4	; sur le LAST disk : No disk for ADD2BCK

	move.l taille_fich,d0
	cmp.l espace_libre,d0
	ble.s enough_place
	bsr vide_cache	; pour ne pas couper la poire en deux
	tst d7
	bmi.s err1
	bsr insert_new_disk
	tst d7
	bmi.s err1

	bsr lit_info_fich	; pour reconstruire afin que la couche appelante
	bsr merdouze	; retrouve ses petits dans le buffer : boot_secteur

enough_place:
	move.l offset_write,d0
	sub.l ad_malloc,d0
	move.w longueur_secteur,d1
	ext.l d1
	sub.l d1,d0		; % au dbut des donnes inscriptibles

	move.l ad_malloc,a0
	move.l d0,512-2-4(a0)
	move.l #'LAST',512-2-4-4(a0)
	move.l temp_for_last,512-2-4-4-4(a0)
	move.w temp_for_last+4,512-2-4-4-4-2(a0)
	clr d7
err1:	rts
	
its_not_me:	move.l ad_name_fich,a0		; pas ficher de rapport...

	tst save_entire_path
	bne.s save_all_p

	add.l save_base_root_lengh,a0	; saute base root
save_all_p:

recop_nom:	move.b (a0)+,(a1)+
	tst.b -1(a1)
	bne.s recop_nom
	
	bsr.s set_path
	file_open read_write,set_name
	save d0
	file_seek #2,d0,#0		; se positionne  la fin
	move.l (sp),d0
	file_write #boot_secteur,#256,d0
	load d0
	file_close d0
	clr d7
	rts
 BSS
temp_for_last:
	ds.w 2+1
 TEXT

		*---------------------
; Pour mettre le Path au path des sets
set_path:	*move.b sets_path,d0
	*sub.b #'A',d0
	*and.w #$ff,d0
	move save_mdrive,-(sp)
	appel dos,$0e,4	; setdrive
	pea save_mpath
	appel dos,$3b,6	; set_path
	move d0,d7
	tst d7
	bmi.s pb_sets_path
	clr d7
pb_sets_path:rts
		*---------------------
lit_info_fich:
	pea buffer		; set dta
	appel dos,$1a,6
	move.w #$23,-(sp)
	move.l ad_name_fich,-(sp)
	appel dos,$4e,8	; fs first
	rts
		*---------------------
delete_files_after_backup:
	file_open read,set_name
	move d0,d7
	tst d7
	bmi err_delete1
	move d7,handle

	file_read #buffer,#64+6,handle
	cmp.l #64+6,d0
	bne.s err_delete2

next_del:	file_read #buffer,#256,handle
	cmp.l #256,d0
	bne.s err_delete3		; fini

	clr.w -(sp)
	move.w #1,-(sp)		; fixer en r/w
	pea buffer+15
	appel dos,$43,10
	tst d0
	bne.s err_delete2

	pea buffer+15
	appel dos,$41,6		; Fdelete
	tst d0
	bne.s err_delete2

	bra.s next_del

err_delete3:clr d7

err_delete2:file_close handle
err_delete1:rts
		*---------------------
debut_boot:	save d0-a6			; boot-sector tel qu'il sera sur disque
	write txt_bck(pc)
	write bck_desc(pc)
	write rc_lf(pc)
	write n_report(pc)
	write rc_lf(pc)
	load d0-a6
	rts
chksum:	dc.w 0
txt_bck:	dc.b 'This disk belongs to a GENUWAX BACKUP set.',rc,lf
	dc.b 'Version release is 1.0. Reformat this disk',rc,lf
	dc.b 'with soft option before using it in a normal way.'
rc_lf:	dc.b rc,lf,rc,lf,0
bck_desc:	dc.b 'Backup description :',rc,lf
desc_boot:	dcb.b 64,32		; decriptif
	dc.b 0
	even
n_report:	dc.b 'Name of set file :',rc,lf
name_report:dcb.b 12,32		; nom du fichier de rapport
	dc.b 0
fin_txt_bck:
	dcb.b 512-($1c+2)-(fin_txt_bck-debut_boot)-2-2-3*4-2,32
	dc.w No_ver_1*256+No_ver_2*16+No_ver_3
	dc.w 0
	dcb.l 3,0
	dc.b '00'

		*---------------------
 DATA
ad_malloc:	dc.l 0
ad_malloc_ver:	dc.l 0

id_guw:	dc.b 'GW BCK'

*warning:	dc.b lf,rc,'Insrez la disquette formate N '
*	dc.b lf,rc,'(A)nnuler     (I)nsrer',0
*disk:	dc.b lf,rc,"Erreur d'criture."
*	dc.b lf,rc,'(A)nnuler     (R)essayer     (N)ew disk',0
*memory:	dc.b lf,rc,'Pas assez de memoire.',0
*info_warning:
*	dc.b lf,rc,'Cette disquette semble contenir des informations.' 
*	dc.b lf,rc,'(A)nnuler     (C)ontinuer',0
 even
		*---------------------
 BSS
ad_name_fich:
	ds.l 1
handle:	ds.w 1
taille_fich:ds.l 1
buffer:	ds.b taille

flag_cache:	ds.w 1
num_disk:	ds.w 1
disque_courant:
	ds.w 1

boot_secteur:
	ds.b 4096

nb_faces:	ds.w 1
nb_pistes:	ds.w 1
nb_sec_pistes:
	ds.w 1
longueur_secteur:
	ds.w 1
espace_libre:
	ds.l 1

zone_tampon:ds.w 4	; recopie des info. de la disquette pour comparaison

last_piste:	ds.w 1

offset_write:
	ds.l 1
save_base_root_lengh:
	ds.l 1

are_there_more:	ds.l 1		; pour slectrix
return_more_names:	ds.b (8+1+3+1)*256
 TEXT

	DATA
*main:	dc.b lf,rc,lf,rc,'Gen & Wax Total Backup Version 9.0'
*	dc.b lf,rc,'(c)Genuwax 28-XI-1993, All rights reserved.'
*	dc.b lf,rc,lf,rc,'Menu principal :'
*	dc.b lf,rc,'(B)ackup     (R)estorer    (C)ontinuer_backup    (S)et-reconstruire   (A)nnuler',0
*ask_recurse:dc.b lf,rc,'Sauvegarde rcursive (Oui/Non)',0
*ask_entire:	dc.b lf,rc,'Sauvegarde du path total (Oui/Non)',0
	even
	TEXT
*--------------------------------------------------------------------------
;A	D	D	2	B	C	K
*--------------------------------------------------------------------------
ADD_TO_BACKUP:
	bsr init_backup2
	move.w #2,at_least_once

	bsr insert_last_disk
	tst d7
	bmi no_add

	lea boot_secteur+($1c+2+name_report-debut_boot),a0
	lea set_name,a1
	lea name_report,a2
	move.w #12-1,d0
.recop_name_r:
	move.b (a0),(a1)+
	move.b (a0)+,(a2)+
	dbf d0,.recop_name_r

	bsr set_path
	file_open read,set_name
	move d0,d7
	tst d7
	bmi not_exis
	save d0
	file_read #buffer,#64+6,d0
	load d0
	file_close d0

	move.w buffer+64,save_entire_path
	move.w buffer+66,d0
	move.w #-204,d7
	cmp.w #$8f8a,d0
	bne not_rv
	move.w buffer+68,d0
	cmp.w No_ver,d0
	bne not_rv

	lea buffer,a0	; Descriptif dans le boot qui sera recopi futurement sur chaque disque
	lea desc_boot,a1
	move.w #64-1,d0
.recop_descr:move.b (a0)+,(a1)+
	dbf d0,.recop_descr

	move.l boot_secteur+512-2-4-4-4,offset_write
	move.w boot_secteur+512-2-4-4-4-2,d0
	move.w d0,num_disk
	cmp.w disque_courant,d0
	beq.s pas_demande
	bsr insert_this_disk
	tst d7
	bmi.s no_add

pas_demande:bsr calcule_all_from_boot_info	; on le fait 2 fois ...

	move.l espace_libre,d0
	move.w longueur_secteur,d1	; + BS
	ext.l d1
	add.l d1,d0			; + BS
	bsr xmalloc
	tst.l d0
	bgt.s .no_bug_mem
	bsr erreur_mem
	bra.s no_add
	
.no_bug_mem:move.l d0,ad_malloc

.retry:	bsr.s read_all_disk
	tst d7
	bpl.s .add

	bsr err_lect_bios
	tst d7
	bpl.s .retry
	bra.s no_add

.add:	move.l offset_write,d0
	sub.l d0,espace_libre
	add.l ad_malloc,d0
	move.w longueur_secteur,d1
	ext.l d1
	add.l d1,d0			; + BS
	move.l d0,offset_write

	move.l ad_malloc,a0
	move.l #'    ',512-2-4-4(a0)	; enlve LAST

	bra redo_next
no_add:	rts

not_rv:	bsr not_right_v		; not right version
	bra.s no_add

not_exis:	bsr dnot_exist		; the corresponding set does not exist
	bra.s no_add

read_all_disk:
	move.l offset_write,d0
	move.w longueur_secteur,d1
	ext.l d1
	add.l d1,d0			; + BS

	divu longueur_secteur,d0	; d'un disk non plein
	swap d0
	tst d0
	beq.s no_rest
	add.l #$10000,d0
no_rest:	swap d0

	save d0
	move.w #0,-(sp)		; drive
	move.w #0,-(sp)		; No secteur o commencer
	move.w #0,-(sp)		; Nombre
	move.l #0,-(sp)
	move.w #0,-(sp)
	appel bios,4,14		; force chgt de disk

	move.w #0,-(sp)		; drive
	appel bios,7,4		; get bpb

	load d0

	move.w #0,-(sp)		; drive
	move.w #0,-(sp)		; No secteur o commencer
	move.w d0,-(sp)		; Nombre
	move.l ad_malloc,-(sp)
	move.w #2,-(sp)
	appel bios,4,14
	move d0,d7			; <0 si erreur
	rts
*--------------------------------------------------------------------------
;C	O	N	S	T	R	UCT
*--------------------------------------------------------------------------
CONSTRUCT:
	bsr desactive_next

	bsr insert_last_disk
	tst d7
	bmi tantpis

	bsr init_restore

	bsr calcule_all_from_boot_info

	move.w boot_secteur+512-2,d0	; No Disk
	sub.w #'00',d0
	move.w d0,current_disk
	move.l boot_secteur+512-2-4,d1	; offset ds disk
	bsr init_ptrs_read
	tst d7
	bmi.s tantpis

	moveq.l #2,d0
	bsr lit_n_octets
	tst d7
	bmi.s tantpis

	clr.l d0
	move.w buffer,d0
	save d0
	bsr lit_n_octets
	load d1
	tst d7
	bmi.s tantpis

	lea info_on_file,a1
	move.w boot_secteur+512-2,d0	; No Disk
	sub.w #'00',d0
	move.w d0,(a1)+
	move.l boot_secteur+512-2-4,(a1)+	; sautera le header tout seul

	lea buffer,a0
	subq #1,d1
cp_all_i:	move.b (a0)+,(a1)+
	dbf d1,cp_all_i

	lea buffer+9,a0
	lea user_path,a1
cp_all_i2:	move.b (a0)+,(a1)+
	tst.b -1(a1)
	bne.s cp_all_i2

	bsr set_path

	bsr restore_file
	clr affiche_sets

tantpis:	bsr active_next
	bsr rends_memoire
	rts
*-----------------------------------------------------------------
write_sets_contents:
	tst.w affiche_sets
	bne no_set_here

	move.w #1,affiche_sets

	bsr set_path

	lea boot_secteur,a6

	pea boot_secteur		; set dta
	appel dos,$1a,6

	move.w #%100011,-(sp)		; tous les fich
	pea sets_only
	appel dos,$4e,8		; fsfirst
	tst d0
	bne no_set_here

next_aff:	file_open read,30(a6)
	move d0,handle
	file_read #buffer,#64,handle
	clr.b buffer+64
	file_close handle

	lea 30(a6),a0		; 08/12 21:45
	lea datus+2,a1
	move.w (a0)+,(a1)+
	addq.l #1,a1
	move.b (a0)+,(a1)+
	move.b (a0)+,(a1)+
	addq.l #1,a1
	move.w (a0)+,(a1)+
	addq.l #1,a1
	move.b (a0)+,(a1)+
	move.b (a0)+,(a1)+

	move.w index_window1,d0
	lea datus,a0
	bsr write_in_window
	move.w index_window1,d0
	lea buffer,a0
	bsr write_in_window

	pea boot_secteur		; set dta
	appel dos,$1a,6

	appel dos,$4f,2		; fsnext
	tst d0
	beq next_aff
no_set_here:

	rts
*-----------------------------------------------------------------
load_preferences:
	file_open read,pref_name
	tst d0
	bmi.s no_prf
	save d0
	file_read #recurse_subdirs,#2*5,d0
	load d0
	file_close d0
no_prf:	rts

SAVE_PREFERENCES:
	bsr.s set_my_own_path
	file_open write,pref_name
	tst d0
	bmi.s no_sv_prf
	save d0
	file_write #recurse_subdirs,#2*5,d0
	load d0
	file_close d0
no_sv_prf:	rts

save_my_own_path:
	appel dos,$19,2		; save current drive
	move d0,save_mdrive

	clr.w -(sp)			; save current path
	pea save_mpath
	appel dos,$47,8

	tst.b save_mpath
	bne.s not_mroot	; tout ca pour le module rcursif
	move.w #'\'*256,save_mpath
not_mroot:	rts

set_my_own_path:
	move.w save_mdrive,-(sp)
	appel dos,$0e,4	; setdrive
	pea save_mpath
	appel dos,$3b,6	; set_path
	rts

	BSS
save_mdrive:ds.w 1
save_mpath:	ds.b 256
	TEXT

*-----------------------------------------------------------------
INFOS_ON_DISK:
	bsr read_boot_sector
	tst d7
	bmi.s .no_disk

	bsr calcule_all_from_boot_info
	bsr FORM_INFO_DISK

.no_disk:	rts
*-----------------------------------------------------------------
	include mod_rec6.s
*-----------------------------------------------------------------
	include gest_rs2.s
*-----------------------------------------------------------------
	section DATA
 even
No_ver:	dc.w No_ver_1*256+No_ver_2*16+No_ver_3
flic:	dc.b lf,rc,"Adding : ",0

text_back:	dc.b 'Choose Files To Backup :',0
text_sets:	dc.b 'Choose Set File :',0
text_restore:dc.b 'Choose Restore Destination Path :',0
text_add2bck:dc.b 'Choose Set where to add files :',0
text_format:dc.b 'Choose your favorite format prog. :',0 

	ifeq QUI
sets_path:	dc.b 'E:\TEMP',0
	endc
	ifeq QUI-2
sets_path:	dc.b 'D:\DEVPAC\SOURCE\GENUWAX',0
	endc
*	dcb.b 200,0
 even
set_name:	dc.b '00000000.GWB',0
 even
descriptif:	dc.b 64,0		; LAISSE CA WAX !!!!!
	dcb.b 64,' '

*descript:	dc.b lf,rc,'Entrez le desciptif du backup : '
lf_rc:	dc.b lf,rc,0

*listesets:	dc.b lf,rc,'Liste des sets disponibles :',0
sets_only:	dc.b '*.GWB',0
	even
datus:	dc.b lf,rc,'27/12 12:30',lf,rc,0
	even
pref_name:	dc.b 'totalbck.inf',0

	section BSS
recurse_subdirs:		; 0=non 1=recurse
	ds.w 1
save_entire_path:		; 0=short 1=long
	ds.w 1
delete_after_bck:		; 0=no 1=yes
	ds.w 1
disable_warnings:		; 0=no 1=yes
	ds.w 1
total_verify:		; 0=no 1=yes
	ds.w 1

affiche_sets:ds.w 1
safe:	ds.l 2
	END

Format du Header sur disque:
	- 1 .W	: longueur du header
	- 9 .B	: heure date taille attribut
	-	: nom avec PATH TOTAL QUOI QU'IL ARRIVE

Format du fichier de rapport
	- 64 .B	: descriptif
	- 1  .W	: path total or not
	- 1  .W	: $8f8a (check good format)
	- 1  .W	: No version
 pour chaque fichier : 
0	- 1 .W	: n disk
2	- 1 .L	: offset / dbut disk (inscriptible/512)
6	- 9 .B	: info fichier : heure.W date.W taille.L attribut.B
15	- 256-15 .B	: nom avec path total
256

Table des erreurs:
 BACKUP
 -200	: L'utilisateur ne veut pas insrer de nouvelle disquette
 -201	: Arret par pression des deux [SHIFT]
 -202	: L'utilisateur veut insrer une nouvelle disquette sur erreur d'criture
 -207	: Run other (formateur)

 RESTORE
 -203	: erreur de lecture du fichier de rapports
 -204	; not a set file or not the right version.

 GEM
 -205	; fichier ressource non trouv
 -206	; erreur dans le fichier ressource

 -207	; erreur de lecture et dsire le fichier suivant

'LAST' figure sur le disque contenant le fichier de rapport donc :
 fin_boot-2-4-4-4-2	: No o reprendre l'criture pour add 2 backup
 fin_boot-2-4-4-4	: offset (cf. ci dessus) pour add 2 backup
 fin_boot-2-4-4	: LAST
 fin_boot-2-4	; offset / dbut donnes incriptibles dudit fichier
; 2+$1c+name_report-debut_boot+boot_secteur	; nom du rapport
